// $Id: padma.js,v 1.3.2.1 2005/05/26 22:27:49 vnagarjuna Exp $ -->

/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Nagarjuna Venna.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Nagarjuna Venna <vnagarjuna@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Browser related
//Used only for special controls

function setTransformedText(text)
{
    //The credit for this piece goes to Jed Brown of the BBCode extension.
    //http://jedbrown.net/1.0
    try {
        var command = "cmd_insertText";
        var controller = document.commandDispatcher.getControllerForCommand(command);
        
        if (controller && controller.isCommandEnabled(command)) {
            controller = controller.QueryInterface(Components.interfaces.nsICommandController);
            var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
            params = params.createInstance(Components.interfaces.nsICommandParams);
            
            params.setStringValue("state_data", text);
            controller.doCommandWithParams(command, params);
        }
    } catch (e) {
        dump("Can't do cmd_insertText! ");
        dump(e+"\n");
    }
}

//Mode 0 is English, 1 is RTS
var mode = 0; 
var fontIndex = 0; //hack

//Transforms input based on mode
function transformInput(inputMethod, input)
{
    if (inputMethod == 1) {
        if (fontIndex == 1)
            return Transformer.convert(input, "Eenadu");
        else if (fontIndex == 2)
            return Transformer.convert(input, "ShreeTel");
    }

    if (inputMethod != 0) {
        alert("Unknown input method " + inputMethod);
        return input;
    }

    if (mode != 0 && mode != 1) {
        alert("Invalid mode " + mode);
        mode = 0;
    }

    var output = "";
    var next = 0;

    do {
        var hash = input.indexOf('#', next);
        if (hash == next) {
            hash = input.indexOf('#', hash + 1);
            if (hash != -1) {
                //Mode remains unchanged because we process text between hashes here
                if (mode == 0)
                    output += Transformer.convert(input.substring(next + 1, hash), "RTS");
                else output += input.substring(next + 1, hash);
            }
            else {
                //Mode changes because there is no terminating hash
                if (mode == 0) {
                    mode = 1;
                    output += Transformer.convert(input.substring(next + 1), "RTS");
                }
                else {
                    mode = 0;
                    output += input.substring(next + 1);
                }
            }
            next = hash + 1;
        }
        //don't change the mode yet because it will be done when it is matched the next time around
        else if (hash != -1) {
            if (mode == 0)
                output += input.substring(next, hash);
            else output += Transformer.convert(input.substring(next, hash), "RTS");
            next = hash;
        }
        //Mode reamins the same because there are no more hashes
        else {
            if (mode == 0)
                output += input.substring(next);
            else output += Transformer.convert(input.substring(next), "RTS");
        }
    } while (hash != -1 && hash < input.length);
    //alert(output);
    return output;
}

var padmaFontList = new Array();
padmaFontList["EENADU"]         = 1;
padmaFontList["SHREE-TEL-0900"] = 2;

//Based on input method, determine if the selected text needs to be transformed
function requiresTransform(inputMethod, node)
{
    if (inputMethod == 0)
        return true;

    for(var parent = node.parentNode; parent.nodeType != 9; parent = parent.parentNode) {
        if (parent.nodeType == 1 && parent.tagName == "FONT") {
            var face = parent.getAttribute("FACE");
            if (face != null) {
                fontIndex = padmaFontList[face.toUpperCase()];
                if (fontIndex != null)
                    return true;
                return false;
            }
        }
    }
    return false;
}

function traverseNode(inputMethod, selection, node, start, end, soff, eoff)
{
    if (node.nodeType == 3) {
        if (selection.containsNode(node, true) && requiresTransform(inputMethod, node)) {
            if (node == start && node == end)
                node.replaceData(soff, eoff - soff, transformInput(inputMethod, node.nodeValue.substring(soff, eoff)));
            else if (node == start)
                node.replaceData(soff, node.length - soff, transformInput(inputMethod, node.nodeValue.substring(soff)));
            else if (node == end)
                node.replaceData(0, eoff, transformInput(inputMethod, node.nodeValue.substring(0, eoff)));
            else node.replaceData(0, node.length, transformInput(inputMethod, node.nodeValue));
        }
    }
    else {
        for(var i = 0; i < node.childNodes.length; ++i) {
            traverseNode(inputMethod, selection, node.childNodes.item(i), start, end, soff, eoff);
        }
    }
}

function traverseDOM(inputMethod, selection)
{
    for(var i = 0; i < selection.rangeCount; i++) {
        var range = selection.getRangeAt(i);
        traverseNode(inputMethod, selection, range.commonAncestorContainer, range.startContainer, 
                     range.endContainer, range.startOffset, range.endOffset);
    }
}

//Callback
function onTransform(inputMethod, start)
{
    initializeRelationships();
    
    //Reset mode
    mode = start;

    var node = document.popupNode;
    var nodeLocalName = node.localName.toUpperCase();

    var selection;

    //Check for Selection in various controls
    //This code is thanks to Jaap Haitsma of the dictionarySearch extension and roachfiend of a million extensions
    //http://roachfiend.com/
    //http://mozdev.org/pipermail/project_owners/2004-March/001833.html
    if ((nodeLocalName == "TEXTAREA") || (nodeLocalName == "INPUT" && (node.type == "text" || node.type == "password"))) {
        selection = node.value.substring(node.selectionStart, node.selectionEnd);
    } else if (nodeLocalName == "OPTION") {
        var parentSelect = node.parentNode;
        if (parentSelect.localName.toUpperCase() == "SELECT") {
            if (parentSelect.multiple) {
                var anOption;
                for (var i = 0; i < parentSelect.options.length; i++) {
                    anOption = parentSelect.options[i];
                    if (anOption.selected) {
                        selection += " " + anOption.value;
                    }
                }
            } else {
                selection = node.value;
            }
        }
    } else if (nodeLocalName == "SELECT") {
        selection = node.options[node.selected].value;
    }
    else {
        //Selection in a regular window
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var selection = focusedWindow.getSelection();
        traverseDOM(inputMethod, selection);
        selection.collapseToEnd();
        return;
    }

    //For the specials
    setTransformedText(transformInput(inputMethod, selection));
}
